package de.fuberlin.wiwiss.d2rq.dblp2jena;

import java.util.ArrayList;
import java.util.List;

import com.hp.hpl.jena.graph.Graph;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;

/**
 * TODO: Describe this type
 * 
 * @author Richard Cyganiak <richard@cyganiak.de>
 * @version $Id$
 */
public class FindTimer {
	private Graph graph;
	private Node subject;
	private Node predicate;
	private Node object;
	private int times;
	private long time = Long.MIN_VALUE;
	private long resultCount = -1;
	private List results = new ArrayList();

	public FindTimer(Graph graph, Node s, Node p, Node o, int times) {
		this.graph = graph;
		this.subject = s;
		this.predicate = p;
		this.object = o;
		this.times = times;
	}

	public void go() {
		int count = 0;
		long start = getCurrentTime();
		for (int i = 0; i < times; i++) {
			count = 0;
			results.clear();
			ExtendedIterator it = graph.find(subject, predicate, object);
			while (it.hasNext()) {
				results.add(it.next());
				count++;
			}
		}
		this.time = getCurrentTime() - start;
		this.resultCount = count;
	}
	
	public long getTime() {
		return time;
	}
	
	public long getResultCount() {
		return resultCount;
	}
	
	public List getResults() {
		return results;
	}

	private long getCurrentTime() {
		return System.currentTimeMillis();
	}
}
