package de.fuberlin.wiwiss.d2rq.dblp2jena;

import com.hp.hpl.jena.db.DBConnection;
import com.hp.hpl.jena.db.IDBConnection;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.ModelMaker;
import com.hp.hpl.jena.shared.AlreadyExistsException;

import de.fuberlin.wiwiss.d2rq.D2RQException;

/**
 * Imports an N-Triples RDF dump into a database-backed Jena model.
 * You have to adjust the source filename and the database connection
 * data before running this.
 * 
 * @author Richard Cyganiak <richard@cyganiak.de>
 * @version $Id$
 */
public class NT2Jena {
	static final String SOURCE_NT_FILE = "file:///Users/richard/d2rq/DBLPConvert/data/dblp.nt";
	static String M_DB_URL = "jdbc:mysql:///dblp_jena"; // database URL
	static String M_DB_USER = "root";     // database user id
	static String M_DB_PASSWD = "";   // database user password
	static String M_DB = "MySQL";  // database engine
	static String M_DBDRIVER_CLASS = "com.mysql.jdbc.Driver";  // database driver

	public static void main(String[] args) throws D2RQException, ClassNotFoundException {
		Class.forName(M_DBDRIVER_CLASS);
		IDBConnection conn = new DBConnection(M_DB_URL, M_DB_USER, M_DB_PASSWD, M_DB);
		ModelMaker maker = ModelFactory.createModelRDBMaker(conn);
		Model model;
		try {
			model = maker.createModel("dblp");
		} catch (AlreadyExistsException aeex) {
			maker.removeModel("dblp");
			model = maker.createModel("dblp");
		}
		model.read(SOURCE_NT_FILE, "N-TRIPLE");
	}
}
